#include "Etagere.h"

constexpr int ligne = 3;
constexpr int colonne = 10;

// Variante avec taille fixe, possibilite de taille dynamique.
//Etagere::Etagere()
//{
//    contenu = new Livre**[ligne];
//    for(int i=0; i<ligne; ++i)
//    {
//        contenu[i] = new Livre*[colonne];
//        for(int j=0; j<colonne; ++j)
//            contenu[i][j] = nullptr;
//    }
//}

Etagere::Etagere()
{
    for(int i=0; i < 3; ++i)
        for(int j=0; j < 10; ++j)
            contenu[i][j] = nullptr;
}

Etagere::~Etagere()
{
    //dtor a ecrire pour la variante.
}

Livre* Etagere::get_book(std::string auteur, std::string titre) const
{
    Livre* current_book = nullptr;
    for(int i=0; i<ligne; ++i)
        for( int j=0; j<colonne; ++j)
        {
            current_book = contenu[i][j];
            if ( (*(current_book->get_auteur()) == auteur) && (current_book->get_titre() == titre) )
                if(current_book->get_etat() == true)
                    return current_book;
        }
    return current_book;
}

void Etagere::set_position(char c, int i)
{
    allee = c;
    numero = i;
}
bool Etagere::add_book(Livre * l, int i, int j)
{
    bool ok = false;
    if( (i >= 0) && (i < 4)) // 3 etages !
        if ( (j >= 0) && (j < 11))
        {
            if (contenu[i][j] == nullptr)
            {
                contenu[i][j] = l;
                ok = true;
            }
        }

    return ok;
}
bool Etagere::add_book(Livre * l)
{
    bool ok = false;

    for(int i=0; i < ligne; ++i)
    {

        for( int j=0; j < colonne; ++j)
        {
            if (ok) continue;
            ok = add_book(l, i, j);
        }
    }

    full = !ok;
    return ok;
}
int Etagere::nb_book() const
{
    int count = 0;
    for(int i=0; i < ligne; ++i)
        for( int j=0; j < colonne; ++j)
            if (contenu[i][j] != nullptr)
                ++count;

    return count;
}
int Etagere::nb_exemplaire(std::string auteur, std::string titre) const
{
    int count = 0;
    std::string zeAuteur;
    std::string zeTitre;
    for(int i=0; i<ligne; ++i)
        for( int j=0; j<colonne; ++j)
        {
            Livre* current_book = contenu[i][j];
            if(current_book != nullptr)
            {
                zeAuteur = *(current_book->get_auteur());
                zeTitre = current_book->get_titre();

                if (zeAuteur == auteur)
                {
                    if (zeTitre == titre)
                        ++count;
                }
            }
            else
            {
                zeAuteur = "";
                zeTitre = "";
            }
        }

    return count;
}
